/*  IRman plugin for xmms by Charles Sielski (stray@teklabs.net) ..
 *  XMMS is Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */
#include "xmms/i18n.h"
#include "ir.h"

static gboolean keepConfGoing;
gboolean irconf_is_going = FALSE;
static void *irconf_mainwin, *irconf_controlwin, *irconf_playlistwin;
static void *dev_entry, *ircode_entry, *playlist_entry, *playlist_spin;

static gchar *ir_control[13] =
{
	N_("Play"),	N_("Stop"),	N_("Pause"),
	N_("Prev"),	N_("Next"),	N_("Vol +"),
	N_("Seek -5s"),	N_("Seek +5s"),	N_("Vol -"),
	N_("Shuffle"),	N_("Repeat"),	N_("Playlist"),
	N_("+100")
};
static gchar *ir_playlist[10] =
{
	N_("0"), N_("1"), N_("2"), N_("3"), N_("4"),
	N_("5"), N_("6"), N_("7"), N_("8"), N_("9")
};

static gchar *irbutton_to_edit;
static gint ir_was_enabled;

static void irconf_ok_cb(void * w, gpointer data)
{}

static void irconf_cancel_cb(void * w, gpointer data)
{}

static gint irconf_codeentry_routine(gpointer data)
{
	unsigned char *code;
	char *text;

	code = ir_poll_code();
	if (code)
	{
		text = ir_code_to_text(code);
	}
	if (keepConfGoing)
		return TRUE;
	else
		return FALSE;
}

static void irconf_control_ok_cb(void * w, gpointer data)
{}

static void irconf_control_cancel_cb(void * w, gpointer data)
{
	keepConfGoing = FALSE;
	ir_close_port();
	if (ir_was_enabled)
		irapp_init_port(ircfg.device);
	irconf_is_going = FALSE;
}

static void irconf_control_cb(void * w, gchar * data)
{}

static void spin_change_cb(void * widget, void * spin)
{}

static void pl_entry_change_cb(void * widget, void * spin)
{}

void ir_configure(void)
{
   irapp_read_config();
}
