/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef MAIN_H
#define MAIN_H

typedef enum
{
	TIMER_ELAPSED, TIMER_REMAINING
}
TimerMode;

typedef struct
{
	gint player_x, player_y;
	gint playlist_x, playlist_y, playlist_width, playlist_height;
	gint equalizer_x, equalizer_y;
	guint snap_distance;
	gboolean use_realtime, shuffle, repeat, doublesize, autoscroll,
	         analyzer_peaks;
	gboolean playlist_visible, equalizer_visible, equalizer_active,
	         player_visible;
	gboolean equalizer_autoload, easy_move, player_shaded, playlist_shaded, equalizer_shaded;
	gboolean allow_multiple_instances, always_show_cb;
	gboolean convert_underscore, convert_twenty;
	gboolean show_numbers_in_pl, snap_windows, save_window_position;
	gboolean dim_titlebar, save_playlist_position;
	gboolean open_rev_order, get_info_on_load;
	gboolean get_info_on_demand, eq_doublesize_linked;
	gboolean sort_jump_to_file, use_eplugins, always_on_top, sticky;
	gboolean no_playlist_advance, smooth_title_scroll;
	gboolean use_backslash_as_dir_delimiter, enable_dga;
	gboolean random_skin_on_play, use_fontsets;
	gboolean mainwin_use_xfont;
	gfloat equalizer_preamp, equalizer_bands[10];
	gchar *skin, *outputplugin, *filesel_path, *playlist_path;
	gchar *playlist_font, *mainwin_font;
	gchar *effectplugin;
	gchar *disabled_iplugins, *enabled_gplugins, *enabled_vplugins;
	gchar *eqpreset_default_file, *eqpreset_extension;
	GList *url_history;
	gint timer_mode, vis_type, analyzer_mode, analyzer_type, scope_mode,
	     vu_mode, vis_refresh;
	gint analyzer_falloff, peaks_falloff;
	gint playlist_position;
	gint pause_between_songs_time;
	gboolean pause_between_songs;
	gint mouse_change;
}
Config;

extern Config cfg;

extern GList *disabled_iplugins;
extern gboolean pposition_broken;

void save_config(void);
void set_timer_mode(TimerMode mode);

#endif
