/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2000  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson, 4Front Technologies
 *  Copyright (C) 2001       Gray Carper, Manu Sporny (xRhino, Inc.)
 *
 *  Daemonization by xRhino, Inc. 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _XMLCOMM_H_
#define _XMLCOMM_H_

#define X_LOCK()    pthread_mutex_lock(&xml_mutex)
#define X_UNLOCK()  pthread_mutex_unlock(&xml_mutex)
#define CLOSING_TAG "</xmmscomm>"

/* XML Handlers */
int xml_parse_this(char *parseme, int isFinal);
void xml_comm_init();
void xml_comm_close();
void xml_comm_reset();
void send_playlist(int sd);
void send_xmlheader(int sd);
void send_state(int sd);
void send_feed_info(int sd, int index);

#endif //_XMLCOMM_H_

